//////////////////////////////////////////////////////////////////////////
//                                                                      //
// atan2.cpp -                                                          //
//                                                                      //
//                              //
//        .                          //
//                                                                      //
// Copyright (c) 2001 RC Module Inc.                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 1     $      $Date:: 2/14/06 8:06p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "math.h"
#include "auxfd.h"

//   
//  iDTBL[i] = atan(1./pow(2,i)) * ((LONG)1 << i) * 0x4000000000000000
extern LONG _iDTBL[90];

#ifdef __cplusplus
extern "C" {
#endif

// atan2(x, y) --
//
//    
//   ,   x/y,   [-Pi, Pi]
//
//    --.
//    CORDIC,    
double atan2 (double f1, double f2){
    LONG Mnt1;             //    
	int Exp1, Sgn1;        //  ,     
    LONG Mnt2;             //    
	int Exp2, Sgn2;        //  ,   
	int NewExp;            //   
	int Sgn=0;             //   
    LONG x, y;             //    
    LONG t;                //       
    LONG atan;             //      
	int i;                 //     
    int j;                 //  ,    
	LONG rez = 0;           //   
	int iMj, iPj;          //      i-j, i+j

    //      
	DstrDouble( f1, Mnt1, Exp1, Sgn1 );

    //    
    DstrDouble( f2, Mnt2, Exp2, Sgn2 );

	//  
	if ( Exp1 == 0x400 ){	
		if (Exp2 == 0x400 || Mnt1)
			return ConstructDouble( 1, 0x400, 0, 0);	//NAN
		else {
			Mnt1 = 0x0010000000000000;                  //  atan2(+inf, c)
			Mnt2 = 0x0000000000000000;
		}
	}
	else if (Exp2 == 0x400){
		if (Mnt2)
			return ConstructDouble( 1, 0x400, 0, 0);	//NAN
		else {
			Mnt1 = 0x0000000000000000;                  //  atan2(c, +inf)
			Mnt2 = 0x0010000000000000;
		}
	}
	if (Exp1 == -0x3ff){
		if(Mnt1)
			Exp1++;
		else if (Exp2 == -0x3ff && !Mnt2){
			_FPIEEE_Signal( _FPIEEE_TLoss );
			return 0;
		}
	}
	if (Exp2 == -0x3ff){
		if(Mnt2)
			Exp2++;
	}

    //      
	Mnt1 <<= 8;
	Mnt2 <<= 8;

    //      ( )
	if (Exp1>Exp2){
		Mnt2 >>= Exp1 - Exp2;
		NewExp = 0;
	}
	else{
		if (Sgn2){
			Mnt1 >>= Exp2 - Exp1;
			NewExp = 0;
		}
		else{
			NewExp = Exp1 - Exp2;
		}
	}

	if (NewExp<-28)
		return f1/f2;

	//     
	x = Mnt2;
	y = Mnt1;
	if (Sgn1)
		y= -y;
	if (Sgn2)
		x= -x;
	j=-NewExp;
	i=j;
	iPj = i + j;
    //    CORDIC,    .
	LONG* tbl = _iDTBL+i;

	while (iPj<61){
		iMj = i - j;
		atan = (*tbl++)>>iMj;
		iPj = i + j;
		t = x;						//  
		if ( y>0){
			x += y>>iPj;		//  
			y -= t>>iMj;
			rez -= atan;
		}
		else{
			x -= y>>iPj;		//  
			y += t>>iMj;
			rez += atan;
		}
		t = x;						//  
		if ( y>0){
			x += y>>iPj;		//  
			y -= t>>iMj;
			rez -= atan;
		}
		else{
			x -= y>>iPj;		//  
			y += t>>iMj;
			rez += atan;
		}
		i++;
	}
	while (iMj<61){		/*  ?  -  i<64-NewExp
						x  ,    (microsoft ++(r))	-
						    .*/
		iMj = i - j;
		atan = (*tbl++)>>iMj;
		if ( y>0){
			y -= x>>iMj;		//  
			rez -= atan;
		}
		else{
			y += x>>iMj;		//  
			rez += atan;
		}
		if ( y>0){
			y -= x>>iMj;		//  
			rez -= atan;
		}
		else{
			y += x>>iMj;		//  
			rez += atan;
		}
		i++;
	}
	if (rez<0){
		rez = -rez;
	}
	else{
		Sgn =1;
	}
    //      
	NewExp++;
	if (rez!=0){
		while (!(rez & 0x4000000000000000)){
			rez <<= 1;
			NewExp--;
		}
	}
	else
		NewExp = -0x3ff;

	//     , ...  
	rez >>=9;
	//    ,  .
	rez = (rez>>1) + (rez & 1);

	if (rez == 0x0020000000000000){	
		rez = 0;
		NewExp++;
	}
    //   double
	return ConstructDouble( rez, NewExp, Sgn, 0);		
}

#ifdef __cplusplus
}
#endif
