//**************************************************************************//
//
//     RC MODULE, LTD.
//
//     NAME:             FHT (Fast Hadamard Transform)
//                       256 points (2**8)  
//
//     Revision Date:    17/03/99
//     Author:           Vitali Kashkarov
//
//                             Header File
//**************************************************************************//
#ifndef _H_HARAMARD_NM
#define _H_HADAMARD_NM

    extern "C"
    {
    // External buffers 
        extern unsigned long GBuff[]; // in Global memory
        extern unsigned long LBuff[]; // in Local memory

    // External Routines, defined in assembly file
        // First 3 steps of FHT in parallel.
        void Steps_1_3(void* ASource, void* AResult );
        // Next 5 steps of FHT in parallel.
        void Steps_4_8(void* ASource, void* AResult );
    }

#endif
//**************************************************************************//
//                              End of file
//**************************************************************************//
